#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/iocs.h>

#define GREEN(x) (x & 0b11111_00000_00000_0)
#define RED(x)   (x & 0b00000_11111_00000_0)
#define BLUE(x)  (x & 0b00000_00000_11111_0)

int main()
{
	unsigned short *GRAM = (unsigned short *)0xC00000;
	unsigned short c;
	int i,x,y,crtmode,ssp;
	unsigned int r,g,b;

	crtmode = _iocs_crtmod(-1);
	if ( crtmode != 12 && crtmode != 13 ) {
		puts("error:Unknown screen mode.");
		exit(1);
	}

	ssp = _iocs_b_super(0);

	for ( y = 0; y < 128; y++ ) {
		if ( y >= 124 ) {
			for ( x = 0; x < 128; x++ )
				GRAM[y*512+x] = 0;
			continue;
		}
		for ( x = 0; x < 128; x++ ) {
//			if ( x < 2 || x >= 126 ) {
//				GRAM[y*512+x] = 0;
//				continue;
//			}

			g = r = b = 0;
			for ( i = 0; i < 16; i++ ) {
				c = GRAM[(y*4+i/4)*512 + x*4+i%4];
				g += GREEN(c);
				r += RED(c);
				b += BLUE(c);
			}

			g = GREEN(g>>4);
			r = RED(r>>4);
			b = BLUE(b>>4);
			GRAM[y*512+x] = g + r + b;
		}
	}

	_iocs_b_super(ssp);
	exit(0);
}
